## mumax3 3.10

=== Makefile ===

# Use the default go compiler
GO_BUILDFLAGS=-compiler gc
# Or uncomment the line below to use the gccgo compiler, which may 
# or may not be faster than gc and which may or may not compile...
# GO_BUILDFLAGS=-compiler gccgo -gccgoflags '-static-libgcc -O4 -Ofast -march=native'

CGO_CFLAGS_ALLOW='(-fno-schedule-insns|-malign-double|-ffast-math)'


.PHONY: all cudakernels clean realclean checktests runtests hooks


all: cudakernels hooks
	go install -v $(GO_BUILDFLAGS) github.com/mumax/3/...

cudakernels:
	cd cuda && $(MAKE)

doc:
	cd doc && $(MAKE)

test: all
	go test -vet=off -i github.com/mumax/3/...
	go test -vet=off $(PKGS)  github.com/mumax/3/...
	cd test && ./run.bash

hooks: .git/hooks/post-commit .git/hooks/pre-commit

.git/hooks/post-commit: post-commit
	ln -sf $(CURDIR)/$< $@

.git/hooks/pre-commit: pre-commit
	ln -sf $(CURDIR)/$< $@

clean:
	rm -frv $(GOPATH)/pkg/*/github.com/mumax/3/*
	rm -frv $(GOPATH)/bin/mumax3*
	cd cuda && $(MAKE) clean

realclean: clean
	cd cuda && ${MAKE} realclean

=== cuda/Makefile ===
# Builds mumax3 cuda kernels and create GO wrappers for the compute capabilities listed in $CUDA_CC. 
# If $CUDA_CC is not defined, then $CUDA_CC is set to "30".
#
# The ${CUDA_HOME}/bin/nvcc compiler is used to compile the cuda kernels. If CUDA_HOME is not defined
# it will look for an nvidia compiler in $PATH instead.
#
# Examples:
#
#    make
#    make CUDA_CC=70
#    make CUDA_CC="30 32 35 37 50 52 53 60 61 62 70"
#    make CUDA_HOME="/usr/local/cuda-9.0" CUDA_CC="30 32 35 37 50 52 53 60 61 62 70"
#
# Different CUDA versions support different compute capabilities, as shown in the list below.
# CUDA SDK  9.0 support for compute capability       30 32 35 37 50 52 53 60 61 62 70
# CUDA SDK  9.1 support for compute capability       30 32 35 37 50 52 53 60 61 62 70
# CUDA SDK  9.2 support for compute capability       30 32 35 37 50 52 53 60 61 62 70 72
# CUDA SDK 10.0 support for compute capability       30 32 35 37 50 52 53 60 61 62 70 72 75
# CUDA SDK 10.1 support for compute capability       30 32 35 37 50 52 53 60 61 62 70 72 75
# CUDA SDK 10.2 support for compute capability       30 32 35 37 50 52 53 60 61 62 70 72 75
# CUDA SDK 11.0 support for compute capability       30 32 35 37 50 52 53 60 61 62 70 72 75 80

SHELL = /bin/bash

# When CUDA_HOME is not an environment variable and is not set on the command line, use the nvcc compiler
# from the PATH
ifeq ($(CUDA_HOME),)
	NVCC=nvcc
else 
	NVCC=${CUDA_HOME}/bin/nvcc 
endif

# When CUDA_CC is not an environment variable and is not set on the command line, use compute capability 3.0
ifeq ($(CUDA_CC),)
    CUDA_CC = 30
endif

# The gcc host compiler for nvcc
ifeq ($(NVCC_CCBIN),)
	NVCC_CCBIN=/usr/bin/gcc
endif

CUDA_VERSION := $(shell $(NVCC) --version | grep "Cuda compilation" | grep -Eo '[+-]?[0-9]+([.][0-9]+)?' | head -n 1)

NVCC_COMPATIBILITY_FLAGS := -std=c++03
ifneq (,$(filter 7.0 7.5 8.0,$(CUDA_VERSION)))
	NVCC_COMPATIBILITY_FLAGS :=
endif

NVCCFLAGS = $(NVCC_COMPATIBILITY_FLAGS) -ccbin=$(NVCC_CCBIN) --compiler-options -Werror --compiler-options -Wall -Xptxas -O3 -ptx

CUDAFILES := $(wildcard *.cu)
WRAPPERS := $(CUDAFILES:.cu=_wrapper.go)


.PHONY: all wrappers clean realclean


all: wrappers
	@echo "Built with CUDA version ${CUDA_VERSION}"
	go install -v


wrappers: $(WRAPPERS)


%_wrapper.go: %.cu cuda2go
	@ rm -f $(basename $<)*.ptx
	@ for cc in $(CUDA_CC); do \
		echo $(NVCC) $(NVCCFLAGS) -arch=compute_$$cc -code=sm_$$cc $< -o $(basename $<)_$$cc.ptx ;\
		     $(NVCC) $(NVCCFLAGS) -arch=compute_$$cc -code=sm_$$cc $< -o $(basename $<)_$$cc.ptx ;\
	done
	@ ./cuda2go $< > /dev/null
	@ gofmt -w -s -l $@ > /dev/null


cuda2go: cuda2go.go
	go build $<


clean:
	rm -vf *.ptx


realclean:
	rm -vf *_wrapper.go *.ptx cuda2go

=== doc/Makefile ===
BUILDDIR="build"
STATIC="static"

# build the html pages in ${BUILDDIR}
.PHONY: html
html: doc mumax3libs
	mkdir -p ${BUILDDIR}
	./doc -examples -builddir ${BUILDDIR}
	cp ${STATIC}/* build

.PHONY: doc
doc:
	go build -v

.PHONY: mumax3libs
mumax3libs:
	go install -v github.com/mumax/3/cmd/...

.PHONY: clean
clean:
	rm -rf build
	rm -f doc

=== debian/changelog ===
mumax3 (3.10-7) unstable; urgency=medium

  * Reupload with binaries because contrib.

 -- Roland Mas <lolando@debian.org>  Tue, 20 Dec 2022 11:43:25 +0100

mumax3 (3.10-6) unstable; urgency=medium

  * Rebuild cuda2go wrappers from source during build to fix "does not use
    nvcc during build", thanks to Andreas Beckmann (Closes: #1021991).

 -- Roland Mas <lolando@debian.org>  Wed, 14 Dec 2022 17:28:43 +0100

mumax3 (3.10-5) unstable; urgency=medium

  * Use helper tools and packages to ensure working nvcc/gcc combination,
    thanks to Andreas Beckmann (this is *part* of #1021991 -- the rest of
    the bug report is a different matter).

 -- Roland Mas <lolando@debian.org>  Wed, 14 Dec 2022 09:59:34 +0100

mumax3 (3.10-4) unstable; urgency=medium

  * Reupload with binaries because contrib.

 -- Roland Mas <lolando@debian.org>  Mon, 14 Mar 2022 13:49:49 +0100

mumax3 (3.10-3) unstable; urgency=medium

  * Reupload with binaries because contrib.

 -- Roland Mas <lolando@debian.org>  Mon, 14 Mar 2022 13:22:42 +0100

mumax3 (3.10-2) unstable; urgency=medium

  * Source-only upload for migration to testing.

 -- Roland Mas <lolando@debian.org>  Tue, 01 Feb 2022 19:39:46 +0100

mumax3 (3.10-1) unstable; urgency=medium

  * Initial release (Closes: #996958)
  * Disable testsuite (requires appropriate hardware).

 -- Roland Mas <lolando@debian.org>  Tue, 26 Oct 2021 21:22:32 +0200

=== debian/control ===
Source: mumax3
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Roland Mas <lolando@debian.org>
Section: contrib/science
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
	       nvidia-cuda-toolkit-gcc,
	       help2man
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/mumax3
Vcs-Git: https://salsa.debian.org/go-team/packages/mumax3.git
Homepage: https://github.com/mumax/3
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/mumax/3

Package: mumax3
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
	 libcudart11.0
Built-Using: ${misc:Built-Using}
Description: GPU-accelerated micromagnetic simulator
 mumax3 is a GPU-accelerated micromagnetic simulation program developed
 at the DyNaMat group of Prof. Van Waeyenberge at Ghent University.
 .
 A speed-up of the order of 100x compared to CPU-based simulations can
 easily be reached, even with relatively inexpensive gaming
 GPUs. Additionally, the software is optimized for low memory use and
 can handle about 16 million FD cells with 2GB of GPU RAM.
 .
 Features:
  - Landau-Lifshitz micromagnetic formalism
  - Magnetostatic field
  - Heisenberg exchange
  - Arbitrary inter-region exchange like RKKY coupling
  - Dzyaloshinskii-Moriya interaction
  - Spin-transfer torque (Zhang-Li and Slonczewski)
  - Uniaxial and cubic magnetocrystalline anisotropy
  - Thermal fluctuations (Brown)
  - Voronoi tessellation
  - Time- and space dependent material parameters
  - Arbitrary complex excitation (field, current)
  - Simulation window can automatically follow a moving domain wall
  - Edge charges can be removed to simulate an infinitely long geometry
  - Optional 1D, 2D or 3D periodic boundary conditions

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

PARALLEL=$(shell echo $$DEB_BUILD_OPTIONS|xargs -n 1|grep ^parallel=|cut -d= -f2)
ifneq ($(strip $(PARALLEL)),)
        MAKE_ARGS=-j$(PARALLEL)
endif

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

override_dh_auto_install:
	dh_auto_install -- --no-source

override_dh_auto_test:

override_dh_auto_clean:
	rm -rf cuda2go
	dh_auto_clean --buildsystem=golang

override_dh_auto_build:
	make -C cuda realclean
	DH_GOLANG_BUILDPKG="github.com/mumax/3/util" dh_auto_build $@ --builddirectory=_build --buildsystem=golang
	mkdir -p cuda2go
	tail -n +2 cuda/cuda2go.go > cuda2go/cuda2go.go
	cd cuda2go && GOPATH=$(CURDIR)/_build GOCACHE=$(CURDIR)/_build/go-build GOMODCACHE=$(CURDIR)/_build/pkg/mod GO111MODULE=off go build .
	cp cuda2go/cuda2go cuda/
	make -C cuda wrappers CUDA_CC="50 52 53 60 61 62 70" $(MAKE_ARGS)
	dh_auto_build $@ --builddirectory=_build --buildsystem=golang
	for i in doc test ; do mv _build/bin/$$i _build/bin/mumax3-$$i ; done
	for i in mumax3 mumax3-convert mumax3-httpfsd mumax3-plot mumax3-script mumax3-server mumax3-doc mumax3-test ; do PATH=_build/bin:$$PATH help2man --output=$$i.1 --version-string=$$(dpkg-parsechangelog -S Version | sed s/-[^-]*$$//) --help-option -help --no-discard-stderr $$i ; done

## mumax3 3.11.0

=== debian/changelog ===
mumax3 (3.11.0-2) experimental; urgency=medium

  * Rebuild with binaries.

 -- Roland Mas <lolando@debian.org>  Tue, 01 Jul 2025 17:45:12 +0200

mumax3 (3.11.0-1) experimental; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Tue, 01 Jul 2025 12:53:16 +0200

mumax3 (3.10-9) unstable; urgency=medium

  * Backport from upstream: additional permission to license to allow
    linking with CUDA.

 -- Roland Mas <lolando@debian.org>  Fri, 27 Sep 2024 19:39:19 +0200

mumax3 (3.10-8) unstable; urgency=medium

  * Bug fix: "hardcoded dependency on libcudart11.0", thanks to Andreas
    Beckmann (Closes: #1040318).

 -- Roland Mas <lolando@debian.org>  Sat, 29 Jul 2023 01:11:00 +0200

## mumax3 3.11.1

=== Makefile ===
--- 
+++ 
@@ -13,9 +13,10 @@
 
 all: cudakernels hooks
 	go install -v $(GO_BUILDFLAGS) github.com/mumax/3/...
+	cd cmd/mumax3/ && $(MAKE)
 
 cudakernels:
-	cd cuda && $(MAKE)
+	cd cuda && $(MAKE) NVCC_CCBIN=$(NVCC_CCBIN)
 
 doc:
 	cd doc && $(MAKE)

=== cuda/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Builds mumax3 cuda kernels and create GO wrappers for the compute capabilities listed in $CUDA_CC. 
-# If $CUDA_CC is not defined, then $CUDA_CC is set to "30".
+# If $CUDA_CC is not defined, then $CUDA_CC is set to "50".
 #
 # The ${CUDA_HOME}/bin/nvcc compiler is used to compile the cuda kernels. If CUDA_HOME is not defined
 # it will look for an nvidia compiler in $PATH instead.
@@ -8,17 +8,17 @@
 #
 #    make
 #    make CUDA_CC=70
-#    make CUDA_CC="30 32 35 37 50 52 53 60 61 62 70"
-#    make CUDA_HOME="/usr/local/cuda-9.0" CUDA_CC="30 32 35 37 50 52 53 60 61 62 70"
+#    make CUDA_CC="50 52 53 60 61 62 70 72 75 80 86"
+#    make CUDA_HOME="/usr/local/cuda-12.6" CUDA_CC="50 52 53 60 61 62 70 72 75 80 86"
 #
-# Different CUDA versions support different compute capabilities, as shown in the list below.
-# CUDA SDK  9.0 support for compute capability       30 32 35 37 50 52 53 60 61 62 70
-# CUDA SDK  9.1 support for compute capability       30 32 35 37 50 52 53 60 61 62 70
-# CUDA SDK  9.2 support for compute capability       30 32 35 37 50 52 53 60 61 62 70 72
+# Different CUDA versions support different compute capabilities, as shown in the list below. See https://stackoverflow.com/a/28933055.
 # CUDA SDK 10.0 support for compute capability       30 32 35 37 50 52 53 60 61 62 70 72 75
 # CUDA SDK 10.1 support for compute capability       30 32 35 37 50 52 53 60 61 62 70 72 75
 # CUDA SDK 10.2 support for compute capability       30 32 35 37 50 52 53 60 61 62 70 72 75
-# CUDA SDK 11.0 support for compute capability       30 32 35 37 50 52 53 60 61 62 70 72 75 80
+# CUDA SDK 11.0 support for compute capability             35 37 50 52 53 60 61 62 70 72 75 80
+# CUDA SDK 11.1-11.7 support for compute capability        35 37 50 52 53 60 61 62 70 72 75 80 86
+# CUDA SDK 11.8 support for compute capability             35 37 50 52 53 60 61 62 70 72 75 80 86 87 89
+# CUDA SDK 12.0+ support for compute capability                  50 52 53 60 61 62 70 72 75 80 86 87 89 90
 
 SHELL = /bin/bash
 
@@ -32,12 +32,12 @@
 
 # When CUDA_CC is not an environment variable and is not set on the command line, use compute capability 3.0
 ifeq ($(CUDA_CC),)
-    CUDA_CC = 30
+	CUDA_CC = 50 # Lowest supported CC for mumax3.11
 endif
 
 # The gcc host compiler for nvcc
 ifeq ($(NVCC_CCBIN),)
-	NVCC_CCBIN=/usr/bin/gcc
+	override NVCC_CCBIN:=/usr/bin/gcc
 endif
 
 CUDA_VERSION := $(shell $(NVCC) --version | grep "Cuda compilation" | grep -Eo '[+-]?[0-9]+([.][0-9]+)?' | head -n 1)

=== doc/Makefile ===
BUILDDIR="build"
STATIC="static"
BENCH="../bench"

# build the html pages in ${BUILDDIR}
.PHONY: html
html: doc mumax3libs gpus
	mkdir -p ${BUILDDIR}
	./doc -examples -builddir ${BUILDDIR}
	cp ${STATIC}/* build

.PHONY: doc
doc:
	go build -v

.PHONY: mumax3libs
mumax3libs:
	go install -v github.com/mumax/3/cmd/...

.PHONY: gpus
gpus:
	# Only attempt move when gnuplot succeeded
	if (cd ${BENCH} && gnuplot gpus.gplot); then \
		mv ${BENCH}/gpus.svg ${STATIC}/; \
	fi

.PHONY: clean
clean:
	rm -rf build
	rm -f doc

=== mag/Makefile ===
all: 
	go install -v

=== cmd/mumax3-convert/Makefile ===
all:
	go install -v

=== cmd/mumax3-httpfsd/Makefile ===
all:
	go install

=== cmd/mumax3/Makefile ===
all:
	@COMMIT_HASH=$(shell git rev-parse --short HEAD 2>/dev/null || echo "unknown"); \
	if [ "$$COMMIT_HASH" = "unknown" ]; then \
		echo "Warning: Could not determine Git commit hash. Using 'unknown'."; \
	fi; \
	go install -ldflags "-X main.commitHash=$$COMMIT_HASH" -v

=== cuda/cu/Makefile ===
all: 6g gccgo doc

6g:
	go install -v
	go tool vet *.go
	gofmt -w *.go

GCCGO=gccgo -gccgoflags '-static-libgcc -O3'

gccgo:
	go build -v -compiler $(GCCGO)

test: 6gtest gccgotest

6gtest: 
	go test

gccgotest: 
	go test -compiler $(GCCGO)

bench: 6gbench gccgobench

6gbench:
	go test -bench=.

gccgobench:
	go test -bench=. -compiler $(GCCGO)

clean:
	go clean

doc:
	godoc github.com/barnex/cuda5/cu > README

=== cuda/cufft/Makefile ===
all: 6g gccgo doc

6g:
	go install -v
	go tool vet *.go
	gofmt -w *.go

GCCGO=gccgo -gccgoflags '-static-libgcc -O3'

gccgo:
	go build -v -compiler $(GCCGO)

test: 6gtest gccgotest

6gtest: 
	go test

gccgotest: 
	go test -compiler $(GCCGO)

bench: 6gbench gccgobench

6gbench:
	go test -bench=.

gccgobench:
	go test -bench=. -compiler $(GCCGO)

clean:
	go clean

doc:
	godoc github.com/barnex/cuda5/cufft > README

=== cuda/curand/Makefile ===
all: 6g gccgo doc

6g:
	go install -v
	gofmt -w *.go

GCCGO=gccgo -gccgoflags '-static-libgcc -O3'

gccgo:
	go build -v -compiler $(GCCGO)

test: 6gtest gccgotest

6gtest: 
	go test

gccgotest: 
	go test -compiler $(GCCGO)

bench: 6gbench gccgobench

6gbench:
	go test -bench=.

gccgobench:
	go test -bench=. -compiler $(GCCGO)

clean:
	go clean

doc:
	godoc github.com/barnex/cuda5/curand > README

=== doc/tex/Makefile ===
mumax3.pdf: mumax3.tex 
	pdflatex -halt-on-error mumax3.tex
	pdflatex -halt-on-error mumax3.tex

.PHONY: clean
clean:
	rm -f *.aux *.bbl *.blg *.ind *.ilg *.log *.toc *.out mumax3.pdf *.idx

=== debian/changelog ===
mumax3 (3.11.1-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Wed, 13 Aug 2025 00:02:17 +0200

=== debian/control ===
--- 
+++ 
@@ -20,7 +20,6 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-	 libcudart11.0
 Built-Using: ${misc:Built-Using}
 Description: GPU-accelerated micromagnetic simulator
  mumax3 is a GPU-accelerated micromagnetic simulation program developed

=== debian/rules ===
--- 
+++ 
@@ -16,14 +16,14 @@
 override_dh_auto_test:
 
 override_dh_auto_clean:
-	rm -rf cuda2go
+	rm -rf cuda2go cuda/cuda2go
 	dh_auto_clean --buildsystem=golang
 
 override_dh_auto_build:
 	make -C cuda realclean
 	DH_GOLANG_BUILDPKG="github.com/mumax/3/util" dh_auto_build $@ --builddirectory=_build --buildsystem=golang
 	mkdir -p cuda2go
-	tail -n +2 cuda/cuda2go.go > cuda2go/cuda2go.go
+	tail -n +3 cuda/cuda2go.go > cuda2go/cuda2go.go
 	cd cuda2go && GOPATH=$(CURDIR)/_build GOCACHE=$(CURDIR)/_build/go-build GOMODCACHE=$(CURDIR)/_build/pkg/mod GO111MODULE=off go build .
 	cp cuda2go/cuda2go cuda/
 	make -C cuda wrappers CUDA_CC="50 52 53 60 61 62 70" $(MAKE_ARGS)

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/" \
  https://github.com/mumax/3/tags .*/v?(\d\S*)\.tar\.gz debian
